Guides / Building Search UI / Going further

Server-side rendering with Angular InstantSearch

This is an advanced guide. If you’ve never used Angular InstantSearch, you should follow the getting-started first.

You can find the result of this guide on the Angular InstantSearch repository.

Angular InstantSearch is compatible with server-side rendering. This guide illustrates how to implement it with @angular/universal.

How server-side rendering works

Server-side rendering uses the TransferState modules from @angular/platform-browser and @angular/platform-server. This module caches the first request your server sends to Algolia to avoid re-triggering it when the Angular application starts on the client.

Set up an empty server-side rendering application

First, you need to generate a clean Angular app and enable server-side rendering.

1
2
ng new server-side-rendering
cd server-side-rendering && ng add @nguniversal/express-engine

Run the following command to ensure everything works. You can also inspect the source code of the page to check if the app was indeed rendered on the server, not just on the client.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
npm build:ssr && npm serve:ssr
# or
yarn build:ssr && yarn serve:ssr


## Install Angular InstantSearch

The goal is to have a working client-side implementation of Angular InstantSearch.

**Install `angular-instantsearch` and its peer dependencies**

<!-- vale Vale.Terms = NO -->
```sh
npm install angular-instantsearch@4 instantsearch.js@4 algoliasearch@4

Import NgAisModule into the main application module

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
 // server-side-rendering/src/app/app.module.ts
 import { NgModule } from '@angular/core';
 import { BrowserModule } from '@angular/platform-browser';
+import { NgAisModule } from "angular-instantsearch";
 
 import { AppRoutingModule } from './app-routing.module';
 import { AppComponent } from './app.component';
 
 
 @NgModule({
   declarations: [
     AppComponent
   ],
   imports: [
     BrowserModule.withServerTransition({ appId: 'serverApp' }),
     AppRoutingModule,
+    NgAisModule.forRoot(),
   ],
   providers: [],
   bootstrap: [AppComponent]
 })
 export class AppModule { }

Create and expose the configuration

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
 import { Component } from '@angular/core';
+import algoliasearch from 'algoliasearch/lite';
+import { InstantSearchOptions } from "instantsearch.js/es/types";

 
 @Component({
   selector: 'app-root',
   templateUrl: './app.component.html',
   styleUrls: ['./app.component.css']
 })
 export class AppComponent {
   title = 'server-side-rendering';
+  config: InstantSearchOptions;

+  constructor() {
+    this.config = {
+      searchClient: algoliasearch('YourApplicationID', 'YourSearchOnlyAPIKey')
+      indexName: 'YourIndexName',
+    };
+  }
 }

Add some minimal markup and styles

1
2
3
4
5
6
<!-- in server-side-rendering/src/app/app.component.html -->
<router-outlet></router-outlet>
<ais-instantsearch [config]="config" >
  <ais-search-box></ais-search-box>
  <ais-hits></ais-hits>
</ais-instantsearch>
1
2
/* server-side-rendering/src/styles.css */
@import '~angular-instantsearch/bundles/instantsearch-theme-algolia.css';

Enable server-side rendering

Import TransferState and HTTPClient modules

These modules help you cache HTTP requests that the server sends to Algolia. This avoids duplicate requests during client-side hydration.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
 // server-side-rendering/src/app/app.module.ts
 import { NgModule } from '@angular/core';
-import { BrowserModule } from '@angular/platform-browser';
+import { BrowserModule, BrowserTransferStateModule } from "@angular/platform-browser";
+import { HttpClientModule } from '@angular/common/http';
 import { NgAisModule } from "angular-instantsearch";
 import { AppRoutingModule } from './app-routing.module';
 import { AppComponent } from './app.component';
 
 
 @NgModule({
   declarations: [
     AppComponent
   ],
   imports: [
     BrowserModule.withServerTransition({ appId: 'serverApp' }),
+    BrowserTransferStateModule,
+    HttpClientModule,
     AppRoutingModule,
     NgAisModule.forRoot(),
   ],
   providers: [],
   bootstrap: [AppComponent]
 })
 export class AppModule { }
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
 // in server-side-rendering/src/app/app.server.module.ts
 import { NgModule } from '@angular/core';
-import { ServerModule } from '@angular/platform-server';
+import { ServerModule, ServerTransferStateModule } from '@angular/platform-server';
 
 import { AppModule } from './app.module';
 import { AppComponent } from './app.component';
 @NgModule({
   imports: [
     AppModule,
     ServerModule,
+    ServerTransferStateModule,
   ],
   bootstrap: [AppComponent],
 })
 export class AppServerModule {}

Create a server-side rendering capable search client

The createSSRSearchClient function wraps the Algolia API client. It enables caching and state transfer from server to client.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
 // server-side-rendering/src/app/app.component.ts
 import { Component } from '@angular/core';
 import { InstantSearchConfig } from "instantsearch.js/es/types";
+import { TransferState, makeStateKey } from '@angular/platform-browser';
+import { HttpClient, HttpHeaders } from '@angular/common/http';
-import algoliasearch from 'algoliasearch/lite';
+import { createSSRSearchClient } from 'angular-instantsearch';
 
 
 @Component({
   selector: 'app-root',
   templateUrl: './app.component.html',
   styleUrls: ['./app.component.css'],
 })
 export class AppComponent {
   title = 'server-side-rendering';
   config: any;
 
   constructor(
+    private httpClient: HttpClient,
+    private transferState: TransferState,
   ) {
     this.config = {
-      searchClient: algoliasearch('YourApplicationID', 'YourSearchOnlyAPIKey')
+      searchClient: createSSRSearchClient({
+        appId: 'YourApplicationID',
+        apiKey: 'YourSearchOnlyAPIKey',
+        makeStateKey,
+        HttpHeaders,
+        transferState: this.transferState,
+        httpClient: this.httpClient,
+      }),
       indexName: 'YourIndexName'
     };
   }
 }

Enable InstantSearch routing

If you want your server to perform a search based on the URL, you need to extend the history router so it’s aware of the server-side rendering context.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
// server-side-rendering/src/app/app.component.ts
-import { Component } from '@angular/core';
+import { Component, Inject, Optional } from '@angular/core';
import { TransferState, makeStateKey } from '@angular/platform-browser';
import { createSSRSearchClient } from 'angular-instantsearch';
import { HttpClient, HttpHeaders } from '@angular/common/http';
+import { history } from 'instantsearch.js/es/lib/routers';
+import { REQUEST } from '@nguniversal/express-engine/tokens';
+import type { Request } from 'express';

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css'],
})
export class AppComponent {
  title = 'server-side-rendering';
  config: any;

  constructor(
    private httpClient: HttpClient,
    private transferState: TransferState,
+   @Optional() @Inject(REQUEST) protected request: Request
  ) {
    this.config = {
      searchClient: createSSRSearchClient({
        makeStateKey,
        HttpHeaders,
        appId: 'YourApplicationID',
        apiKey: 'YourSearchOnlyAPIKey',
        transferState: this.transferState,
        httpClient: this.httpClient,
      }),
      indexName: 'YourIndexName',
+     routing: history({
+       getLocation: () => {
+         if (this.request) {
+           const req = this.request;
+           const protocol =
+             (req.headers.referer && req.headers.referer.split('://')[0]) ||
+             'https';
+           const url = `${protocol}://${req.headers.host}${req.url}`;
+           return (new URL(url) as unknown) as Location;
+         }
+         return window.location;
+       },
+     }),
    };
  }
}

This lets the router read the URL from the server request via this.request and use it to perform a search based on the URL. On the client side, it will use window.location as usual.

You’re now ready to build and test server-side rendering.

1
2
> npm run build:ssr && npm run serve:ssr
> open http://localhost:4000

If the app runs without errors, it means server-side rendering is working. You can now add more Angular InstantSearch widgets on your search page component and run:

You have now fully universal Angular InstantSearch application running on your server and browser! If you want to run the application directly we provide a complete example that you can find on the angular-instantsearch GitHub repository.

Did you find this page helpful?

Skip to main content
This is the React InstantSearch v7 documentation. If you’re upgrading from v6, see the upgrade guide. If you were using React InstantSearch Hooks, this v7 documentation applies—just check for necessary changes. To continue using v6, you can find the archived documentation.
Server-side rendering (SSR) lets you generate HTML from InstantSearch components on the server. Integrating SSR with React InstantSearch:
  • Improves general performance: the browser directly loads with HTML containing search results, and React preserves the existing markup (hydration) instead of re-rendering everything.
  • Improves perceived performance: users don’t see a UI flash when loading the page, but directly the search UI. This can also improve your Largest Contentful Paint score.
  • Improves SEO: the content is accessible to any search engine, even those that don’t use JavaScript.
Here’s the SSR flow for InstantSearch:
  1. On the server, retrieve the initial search results of the current search state.
  2. Then, on the server, render these search results to HTML and send the response to the browser.
  3. Then, on the browser, load the JavaScript code for InstantSearch.
  4. Then, on the browser, hydrate the server-side rendered InstantSearch app.
React InstantSearch is compatible with server-side rendering. The library provides an API that works with any SSR solution. For more information, see:

With Next.js (App router)

As of Next.js 13, you can use the App Router to structure your app. The App Router has a different approach to data fetching than the Pages Router, which changes the approach to server-side rendering. To support server-side rendering for the App Router, use the react-instantsearch-nextjs package. It provides an InstantSearchNext component that replaces your InstantSearch component.

Install react-instantsearch-nextjs

First, make sure you have the correct dependencies installed:
  • react-instantsearch >= 7.1.0
  • next >= 13.14.0
Then, install the react-instantsearch-nextjs package:
npm install react-instantsearch-nextjs

Usage

Your search component must be in its own file, and it shouldn’t be named page.js or page.tsx. To render the component in the browser and allow users to interact with it, include the “use client” directive at the top of your code.
React
"use client"; 
import { liteClient as algoliasearch } from "algoliasearch/lite";
import { InstantSearch, SearchBox } from "react-instantsearch";

const searchClient = algoliasearch("ALGOLIA_APPLICATION_ID", "ALGOLIA_SEARCH_API_KEY");

export function Search() {
  return (
    <InstantSearch indexName="YourIndexName" searchClient={searchClient}>
      <SearchBox />
      {/* other widgets */}
    </InstantSearch>
  );
}
Import the InstantSearchNext component from the react-instantsearch-nextjs package, and replace the InstantSearch component with it, without changing the props.
React
'use client';
import { liteClient as algoliasearch } from 'algoliasearch/lite';
import {
- InstantSearch,
  SearchBox,
} from 'react-instantsearch';
+import { InstantSearchNext } from 'react-instantsearch-nextjs';

const searchClient = algoliasearch('ALGOLIA_APPLICATION_ID', 'ALGOLIA_SEARCH_API_KEY');

export function Search() {
  return (
-   <InstantSearch indexName="YourIndexName" searchClient={searchClient}>
+   <InstantSearchNext indexName="YourIndexName" searchClient={searchClient}>
      <SearchBox />
      {/* other widgets */}
-   </InstantSearch>
+   </InstantSearchNext>
  );
}
To serve your search page at /search, create an app/search directory. Inside it, create a page.js file (or page.tsx if you’re using TypeScript). Make sure to configure your route segment to be dynamic so that Next.js generates a new page for each request.
React
// app/search/page.js or app/search/page.tsx
import { Search } from "./Search"; // change this with the path to your <Search> component

export const dynamic = "force-dynamic";

export default function Page() {
  return <Search />;
}
You can now visit /search to see your server-side rendered search page.
If you were previously using getServerState in getServerSideProps with the Pages Router, remove any references to it. It’s not needed with the App Router.

Composing hooks

Due to the way the App Router and InstantSearchNext are implemented, you can’t compose hooks the same way as you would normally do in React InstantSearch. All React InstantSearch hooks have a skipSuspense option that you can set to true to skip the suspense behavior. This should be done to all hooks but the last one in your custom component.
React
export function MyCustomFilters() {
  const { items: brands } = useRefinementList(
    {
      attribute: 'brand',
    },
    { skipSuspense: true }
  );
  const { items: categories } = useRefinementList({ attribute: 'category' });

  return (
    // Render your filters here
  );
}
That way, categories will properly render on the server.
You will see a warning in the console if we detect that more widgets are rendered after suspense. This may be a false positive if you are using multi-index or dynamic widgets. You can ignore it in that case, and set the ignoreMultipleHooksWarning prop to true on InstantSearchNext.

Static site generation with dynamic route segments

You can generate a static version of your search page at build time using Next’s generateStaticParams. Static site generation (pre-rendering) and server-side rendering are essentially the same. The key difference is timing: static generation occurs at build time, while server-side rendering occurs on request. Adopt the same usage recommendations for both server-side rendering and static site generation.
React
// app/[slug]/page.js or app/[slug]/page.tsx
export const dynamicParams = true;

export async function generateStaticParams() {
  const posts = await fetch(/* ... */).then((res) => res.json());
  return posts.map((post) => ({
    slug: post.slug,
  }));
}

export default async function Page({ params }) {
  const { slug } = await params;
  /* ... */
  return <Search /* ... */ />;
}
To statically render all paths at runtime, set the dynamic route segment to 'force-static'.

Enabling routing

To enable routing, add a boolean routing prop to InstantSearchNext.
React
function Search() {
  return (
    <InstantSearchNext
      indexName="YourIndexName"
      searchClient={searchClient}
      routing
    >
      {/* widgets */}
    </InstantSearchNext>
  );
}
To customize the way InstantSearch maps the state to the route, pass an object to routing, where router has the same options as history, and stateMapping has the same options as the one in InstantSearch.
React
<InstantSearchNext
  routing={{
    router: {
      cleanUrlOnDispose: false,
      windowTitle(routeState) {
        const indexState = routeState.indexName || {};
        return indexState.query
          ? `MyWebsite - Results for: ${indexState.query}`
          : "MyWebsite - Results page";
      },
    },
  }}
>
  {/* widgets */}
</InstantSearchNext>;

Dynamic routes

If you have a dynamic route, such as /search/[brand], you may get CLS (Cumulative Layout Shift) issues when navigating between pages, especially if you are using Next.js Link components. To avoid this, use the createInstantSearchNextInstance function from the react-instantsearch-router-nextjs package to create an instance which will be shared across all pages.
React
import {
  createInstantSearchNextInstance,
  InstantSearchNext,
} from "react-instantsearch-nextjs";

const searchClient = algoliasearch("ALGOLIA_APPLICATION_ID", "ALGOLIA_SEARCH_API_KEY");
const categoryPageInstance = createInstantSearchNextInstance();

export function BrandPageSearch({ brand }) {
  return (
    <InstantSearchNext
      indexName="YourIndexName"
      searchClient={searchClient}
      instance={categoryPageInstance}
    >
      <Configure filters={`brand:${brand}`} />
      {/* other widgets */}
    </InstantSearchNext>
  );
}
You can see a full example of this in the Next.js dynamic routes example.

With the Next.js Pages Router

Server-side rendering a page with the Pages Router in Next.js is split in two parts: a function that returns data from the server, and a React component for the page that receives this data. On the page, wrap the search experience with the InstantSearchSSRProvider component. This provider receives the server state and forwards it to the entire InstantSearch app.

Server-side rendering

In Next’s getServerSideProps, you can use getServerState to return the server state as a prop. To support routing, you can use the createInstantSearchRouterNext function from the react-instantsearch-router-nextjs package.
// index.js
import { renderToString } from "react-dom/server";
import { liteClient as algoliasearch } from "algoliasearch/lite";
import {
  InstantSearch,
  InstantSearchSSRProvider,
  getServerState,
} from "react-instantsearch";
import { history } from "instantsearch.js/es/lib/routers/index.js";
import singletonRouter from "next/router";
import { createInstantSearchRouterNext } from "react-instantsearch-router-nextjs";

const searchClient = algoliasearch("undefined", "undefined");

export default function SearchPage({ serverState, serverUrl }) {
  return (
    <InstantSearchSSRProvider {...serverState}>
      <InstantSearch
        searchClient={searchClient}
        indexName="YourIndexName"
        routing={{
          router: createInstantSearchRouterNext({ singletonRouter, serverUrl }),
        }}
      >
        {/* Widgets */}
      </InstantSearch>
    </InstantSearchSSRProvider>
  );
}

export async function getServerSideProps({ req }) {
  const protocol = req.headers.referer?.split["://"](0) || "https";
  const serverUrl = `${protocol}://${req.headers.host}${req.url}`;
  const serverState = await getServerState(
    <SearchPage serverUrl={serverUrl} />,
    { renderToString },
  );

  return {
    props: {
      serverState,
      serverUrl,
    },
  };
}
Check the complete SSR example with Next.js.

Static site generation

You can generate a static version of your search page at build time using Next’s getStaticProps. Static site generation (or pre-rendering) is essentially the same thing as server-side rendering, except the latter happens at request time, while the former happens at build time. You can use the same InstantSearchSSRProvider and getServerState APIs for both server-side rendering and static site generation.
// index.js
import { renderToString } from "react-dom/server";
import { liteClient as algoliasearch } from "algoliasearch/lite";
import {
  InstantSearch,
  InstantSearchSSRProvider,
  getServerState,
} from "react-instantsearch";

const searchClient = algoliasearch("undefined", "undefined");

export default function SearchPage({ serverState }) {
  return (
    <InstantSearchSSRProvider {...serverState}>
      <InstantSearch searchClient={searchClient} indexName="YourIndexName">
        {/* Widgets */}
      </InstantSearch>
    </InstantSearchSSRProvider>
  );
}

export async function getStaticProps() {
  const serverState = await getServerState(<SearchPage />, { renderToString });
  return {
    props: {
      serverState,
    },
  };
}

Dynamic routes

If you want to generate pages dynamically—for example, one for each brand—you can use Next’s getStaticPaths API. The following example uses dynamic routes along with getStaticPaths to create one page per brand.
// pages/brands/[brand].js
import { renderToString } from "react-dom/server";
import { liteClient as algoliasearch } from "algoliasearch/lite";
import {
  InstantSearch,
  InstantSearchSSRProvider,
  SearchBox,
  Hits,
  Configure,
  getServerState,
} from "react-instantsearch";

const searchClient = algoliasearch("undefined", "undefined");

export default function BrandPage({ brand, serverState }) {
  return (
    <InstantSearchSSRProvider {...serverState}>
      <InstantSearch searchClient={searchClient} indexName="YourIndexName">
        <Configure facetFilters={`brand:${brand}`} />
        <SearchBox />
        <Hits />
      </InstantSearch>
    </InstantSearchSSRProvider>
  );
}

export async function getStaticPaths() {
  return {
    // You can retrieve your brands from an API, a database, a file, etc.
    paths: [{ params: { brand: "Apple" } }, { params: { brand: "Samsung" } }],
    fallback: "blocking", // or `true` or `false`
  };
}

export async function getStaticProps({ params }) {
  if (!params) {
    return { notFound: true };
  }

  const serverState = await getServerState(<BrandPage brand={params.brand} />, {
    renderToString,
  });

  return {
    props: {
      brand: params.brand,
      serverState,
    },
  };
}
If you have a reasonable amount of paths to generate and this number doesn’t change much, you can generate them all at build time. In this case, you can set fallback: false, which will serve a 404 page to users who try to visit a path that doesn’t exist (for example, a brand that isn’t in your dataset). If there are many categories and generating them all significantly slows down your build, you can pre-render only a subset of them (for example, the most popular ones) and generate the rest on the fly. With fallback: true, whenever a user visits a path that doesn’t exist, your getStaticProps code runs on the server and the page is generated once for all subsequent users. Users see a loading screen that you can implement with router.isFallback until the page is ready. With fallback: 'blocking', the scenario is the same as with fallback: true but there’s no loading screen. The server only returns the HTML once the page is generated.

With Remix

Remix is a full-stack web framework that encourages usage of runtime servers, notably for server-side rendering. Server-side rendering a page in Remix is split in two parts:
  • A loader that returns data from the server,
  • A React component for the page that receives this data.
In the page, you need to wrap the search experience with the InstantSearchSSRProvider component. This provider receives the server state and forwards it to the entire InstantSearch app. In Remix’ loader, you can use getServerState to return the server state. To support routing, forward the server’s request URL to the history router.
// index.js
import { renderToString } from "react-dom/server";
import { liteClient as algoliasearch } from "algoliasearch/lite";
import {
  InstantSearch,
  InstantSearchSSRProvider,
  getServerState,
} from "react-instantsearch";
import { history } from "instantsearch.js/cjs/lib/routers/index.js";

import { json } from "@remix-run/node";
import { useLoaderData } from "@remix-run/react";

const searchClient = algoliasearch("undefined", "undefined");

export async function loader({ request }) {
  const serverUrl = request.url;
  const serverState = await getServerState(<Search serverUrl={serverUrl} />, {
    renderToString,
  });

  return json({
    serverState,
    serverUrl,
  });
}

function Search({ serverState, serverUrl }) {
  return (
    <InstantSearchSSRProvider {...serverState}>
      <InstantSearch
        searchClient={searchClient}
        indexName="YourIndexName"
        routing={{
          router: history({
            getLocation() {
              if (typeof window === "undefined") {
                return new URL(serverUrl);
              }

              return window.location;
            },
          }),
        }}
      >
        {/* Widgets */}
      </InstantSearch>
    </InstantSearchSSRProvider>
  );
}

export default function HomePage() {
  const { serverState, serverUrl } = useLoaderData();

  return <Search serverState={serverState} serverUrl={serverUrl} />;
}
Check out the complete examples:

With a custom server

This guide shows how to server-side render your app with Express. However, you can follow the same approach with any Node.js server. The example in this guide has three files:
  • App.js: the React component shared between the server and the browser
  • server.js: the server entry to a Node.js HTTP server
  • browser.js: the browser entry (which gets compiled to assets/bundle.js)
1

Create the React component

App.js is the main entry point to your React app. It exports an App component that you can render both on the server and in the browser.The InstantSearchSSRProvider component receives the server state and forwards it to InstantSearch.
// App.js
import { liteClient as algoliasearch } from "algoliasearch/lite";
import React from "react";
import { InstantSearch, InstantSearchSSRProvider } from "react-instantsearch";

const searchClient = algoliasearch("undefined", "undefined");

function App({ serverState }) {
  return (
    <InstantSearchSSRProvider {...serverState}>
      <InstantSearch indexName="YourIndexName" searchClient={searchClient}>
        {/* Widgets */}
      </InstantSearch>
    </InstantSearchSSRProvider>
  );
}

export default App;
2

Server-side render the page

When you receive the request on the server, you need to retrieve the server state so you can pass it down to App. This is what getServerState does: it receives your InstantSearch app and computes a search state from it.In the server.js file:
JavaScript
import express from "express";
import React from "react";
import { renderToString } from "react-dom/server";
import { getServerState } from "react-instantsearch";
import App from "./App";

const app = express();

app.get("/", async (req, res) => {
  const serverState = await getServerState(<App />, { renderToString });
  const html = renderToString(<App serverState={serverState} />);

  res.send(
    `
  <!DOCTYPE html>
  <html>
    <head>
      <script>window.__SERVER_STATE__ = ${JSON.stringify(serverState)};</script>
    </head>
    <body>
      <div id="root">${html}</div>
    </body>
    <script src="/assets/bundle.js"></script>
  </html>
    `,
  );
});

app.listen(8080);
Here, the server:
  1. Retrieves the server state with getServerState.
  2. Renders the App as HTML with this server state.
  3. Sends the HTML to the browser.
Since you’re sending plain HTML to the browser, you need a way to forward the server state object so you can reuse it in your InstantSearch app. To do so, you can serialize it and store it on the window object (here on the __SERVER_STATE__ global), for later reuse in browser.js.
3

Hydrate the app in the browser

Once the browser has received HTML from the server, the final step is to connect this markup to the interactive app. This step is called hydration.In the browser.js file:
JavaScript
import React from "react";
import { hydrate } from "react-dom";
import App from "./App";

hydrate(
  <App serverState={window.__SERVER_STATE__} />,
  document.querySelector("#root"),
);

delete window.__SERVER_STATE__;
Deleting __SERVER_STATE__ from the global object allows the server state to be garbage collected.
4

Support routing

Server-side rendered search experiences should be able to generate HTML based on the current URL. You can use the history router to synchronize InstantSearch with the browser URL.
// App.js
import { liteClient as algoliasearch } from 'algoliasearch/lite';
+import { history } from 'instantsearch.js/es/lib/routers';
+// or cjs if you're running in a CommonJS environment
+// import { history } from 'instantsearch.js/cjs/lib/routers';
import React from 'react';
import {
  InstantSearch,
  InstantSearchSSRProvider,
} from 'react-instantsearch';

const searchClient = algoliasearch('undefined', 'undefined');

-function App({ serverState }) {
+function App({ serverState, serverUrl }) {
  return (
    <InstantSearchSSRProvider {...serverState}>
      <InstantSearch
        indexName="YourIndexName"
        searchClient={searchClient}

-       routing={{
-         router: history({
-           getLocation: () =>
-             typeof window === 'undefined' ? serverUrl : window.location,
-         }),
-       }}
      >
        {/* Widgets */}
      </InstantSearch>
    </InstantSearchSSRProvider>
  );

}

export default App;
You can rely on window.location when rendering in the browser, and use the location provided by the server when rendering on the server.In the server.js file, recreate the URL and pass it to the App:
JavaScript
import express from 'express';
import React from 'react';
import { renderToString } from 'react-dom/server';
import { getServerState } from 'react-instantsearch';
import App from './App';

const app = express();

app.get('/', async (req, res) => {
+ const serverUrl = new URL(
+   `${req.protocol}://${req.get('host')}${req.originalUrl}`
+ );
- const serverState = await getServerState(<App />, { renderToString });
+ const serverState = await getServerState(<App serverUrl={serverUrl} />, {
+   renderToString,
+ });
- const html = renderToString(<App serverState={serverState} />);
+ const html = renderToString(<App serverState={serverState} serverUrl={serverUrl} />);

  res.send(
    `
  <!DOCTYPE html>
  <html>
    <head>
      <script>window.__SERVER_STATE__ = ${JSON.stringify(serverState)};</script>
    </head>
    <body>
      <div id="root">${html}</div>
    </body>
    <script src="/assets/bundle.js"></script>
  </html>
    `
  );
});

app.listen(8080);
Last modified on June 16, 2026

Skip to main content
You’re reading the documentation for Vue InstantSearch v4. Read the migration guide to learn how to upgrade from v3 to v4. You can still find the v3 documentation for this page.
Server-side rendering (SSR) describes a technique for rendering websites. When you request an SSR page, the HTML is rendered on the server and then sent to your client. The main steps to implement server-side rendering with Algolia are: On the server:
  1. Request search results from Algolia
  2. Render the Vue app with the results of the request
  3. Store the search results in the page
  4. Return the HTML page as a string
On the client:
  1. Read the search results from the page
  2. Render (or hydrate) the Vue app with the search results
You can build server-side rendered apps with Vue.js in different ways—for example, using the Vue CLI or Nuxt.js. For code examples, see these GitHub repositories:

With Vue CLI

Open CodeSandbox

Run and edit the Server-side rendering example in CodeSandbox.

Explore source code

Browse the source for the Server-side rendering example on GitHub.
1

Create Vue app with SSR plugin

Use the Vue CLI to create the app and add the SSR plugin:
Command line
vue create algolia-ssr-example
cd algolia-ssr-example
vue add router
vue add @akryum/ssr
2

Start the development server

Run npm run ssr:serve.
3

Install Vue InstantSearch

4

Add Vue InstantSearch to your app

Add the following to the src/main.js file:
import {
  AisInstantSearchSsr,
  createServerRootMixin,
} from "vue-instantsearch/vue3/es";

Vue.use(VueInstantSearch);
5

Build a search interface

Create a new page src/views/Search.vue and build a search interface:
Vue
<template>
  <ais-instant-search :search-client="searchClient" index-name="instant_search">
    <ais-search-box />
    <ais-stats />
    <ais-refinement-list attribute="brand" />
    <ais-hits>
      <template v-slot:item="{ item }">
        <p>
          <ais-highlight attribute="name" :hit="item" />
        </p>
        <p>
          <ais-highlight attribute="brand" :hit="item" />
        </p>
      </template>
    </ais-hits>
    <ais-pagination />
  </ais-instant-search>
</template>

<script>
import { liteClient as algoliasearch } from "algoliasearch/lite";
const searchClient = algoliasearch(
  "latency",
  "6be0576ff61c053d5f9a3225e2a90f76",
);

export default {
  data() {
    return {
      searchClient,
    };
  },
};
</script>
6

Add route to search interface page

Add route to this page in src/router.js:
JavaScript
import Vue from "vue";
import Router from "vue-router";
import Home from "./views/Home.vue";
import Search from "./views/Search.vue";

Vue.use(Router);

export function createRouter() {
  return new Router({
    mode: "history",
    base: process.env.BASE_URL,
    routes: [
      // ...
      {
        path: "/search",
        name: "search",
        component: Search,
      },
    ],
  });
}
7

Update the header

Update in src/App.vue:
Vue
<template>
<div id="app">
<div id="nav">
    <router-link to="/">Home</router-link> |
    <router-link to="/about">About</router-link> |
    <router-link to="/search">Search</router-link>
</div>
<router-view />
</div>
</template>
8

Apply styling

Add instantsearch.css to public/index.html:
HTML
<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/instantsearch.css@8.17.0/themes/satellite-min.css" integrity="sha256-9IzFBYv2mMhTgjMM2RxtALa57QMI2MFBAbyc8nIiki4=" crossorigin="anonymous">
9

Add modules to configuration

Vue InstantSearch uses ES modules, but the app runs on the server, with Node.js. That’s why you need to add these modules to the vue.config.js configuration file:
JavaScript
module.exports = {
  pluginOptions: {
    ssr: {
      nodeExternalsWhitelist: [
        /\.css$/,
        /\?vue&type=style/,
        /vue-instantsearch/,
        /instantsearch.js/,
      ],
    },
  },
};
At this point, Vue.js renders the app on the server. But when you go to /search in your browser, you won’t see the search results on the page. That’s because, by default, Vue InstantSearch starts searching and showing results after the page is rendered for the first time.
10

Create a backend instance

To perform searches on the backend as well, you need to create a backend instance in src/main.js:
import VueInstantSearch, {
  createServerRootMixin,
} from "vue-instantsearch/vue3/es";
import { liteClient as algoliasearch } from "algoliasearch/lite";

const searchClient = algoliasearch(
  "latency",
  "6be0576ff61c053d5f9a3225e2a90f76",
);

export async function createApp({
  renderToString,
  beforeApp = () => {},
  afterApp = () => {},
} = {}) {
  const router = createRouter();

  //Pprovide access to all components
  Vue.use(VueInstantSearch);

  await beforeApp({
    router,
  });

  const app = new Vue({
    // Provide access to the instance
    mixins: [
      createServerRootMixin({
        searchClient,
        indexName: "instant_search",
      }),
    ],
    serverPrefetch() {
      return this.instantsearch.findResultsState({
        component: this,
        renderToString,
      });
    },
    beforeMount() {
      if (typeof window === "object" && window.__ALGOLIA_STATE__) {
        this.instantsearch.hydrate(window.__ALGOLIA_STATE__);
        delete window.__ALGOLIA_STATE__;
      }
    },
    router,
    render: (h) => h(App),
  });

  const result = {
    app,
    router,
  };

  await afterApp(result);

  return result;
}
The Vue app can now inject the backend instance of Vue InstantSearch.
11

Replace InstantSearch with SSR InstantSearch

In the main file, replace ais-instant-search with ais-instant-search-ssr. You can also remove its props since they’re now passed to the createServerRootMixin function.
Vue
<template>
  <ais-instant-search-ssr>
    <!-- ... -->
  </ais-instant-search-ssr>
</template>

12

Add the InstantSearch state

To save the results on the backend, add the InstantSearch state to the context using the getState function:
JavaScript
import _renderToString from "vue-server-renderer/basic";
import { createApp } from "./main";

function renderToString(app) {
  return new Promise((resolve, reject) => {
    _renderToString(app, (err, res) => {
      if (err) reject(err);
      resolve(res);
    });
  });
}

export default (context) => {
  return new Promise(async (resolve, reject) => {
    // Read the provided instance
    const { app, router, instantsearch } = await createApp({ renderToString });

    router.push(context.url);

    router.onReady(() => {
      // Save the results once rendered fully.
      context.rendered = () => {
        context.algoliaState = app.instantsearch.getState();
      };

      const matchedComponents = router.getMatchedComponents();

      // Find the root component that handles the rendering
      Promise.all(
        matchedComponents.map((Component) => {
          if (Component.asyncData) {
            return Component.asyncData({
              route: router.currentRoute,
            });
          }
        }),
      ).then(() => resolve(app));
    }, reject);
  });
};
13

Rehydrate the app

Rehydrate the app with the initial request once you start searching. For this, you need to save the data on the page. Vue CLI provides a way to read the value on the context and save it in public/index.html:
HTML
<!DOCTYPE html>
<html>
    <body>
    <!--vue-ssr-outlet-->
    {{{ renderState() }}}
    {{{ renderState({ contextKey: 'algoliaState', windowKey: '__ALGOLIA_STATE__' }) }}}
    {{{ renderScripts() }}}
    </body>
</html>

With Nuxt 2

The following section describes how to set up server-side rendering with Vue InstantSearch and Nuxt 2. Check the community for solutions for Nuxt 3.

Open CodeSandbox

Run and edit the Server-side rendering example in CodeSandbox.

Explore source code

Browse the source for the Server-side rendering example on GitHub.
1

Create Nuxt app with Vue InstantSearch

Create a Nuxt app and add vue-instantsearch:
Command line
npx create-nuxt-app algolia-nuxt-example
cd algolia-nuxt-example
npm install vue-instantsearch algoliasearch
2

Add modules to configuratio

Vue InstantSearch uses ES modules, but the app runs on the server, with Node.js. That’s why you need to add these modules to the nuxt.config.js configuration file:
JavaScript
module.exports = {
  build: {
    transpile: ["vue-instantsearch", "instantsearch.js/es"],
  },
};
3

Build a search interface

Create a new page pages/search.vue and build a Vue InstantSearch interface:
Vue
<template>
  <ais-instant-search :search-client="searchClient" index-name="instant_search">
    <ais-search-box />
    <ais-stats />
    <ais-refinement-list attribute="brand" />
    <ais-hits>
      <template v-slot:item="{ item }">
        <p>
          <ais-highlight attribute="name" :hit="item" />
        </p>
        <p>
          <ais-highlight attribute="brand" :hit="item" />
        </p>
      </template>
    </ais-hits>
    <ais-pagination />
  </ais-instant-search>
</template>
4

Apply styling

Add the component declarations and the style sheet:
import { liteClient as algoliasearch } from "algoliasearch/lite";
import {
	AisHighlight,
	AisHits,
	AisInstantSearch,
	AisPagination,
	AisRefinementList,
	AisSearchBox,
	AisStats,
	createServerRootMixin,
} from "vue-instantsearch/vue3/es";

const searchClient = algoliasearch(
	"latency",
	"6be0576ff61c053d5f9a3225e2a90f76",
);

export default {
	components: {
		AisInstantSearch,
		AisRefinementList,
		AisHits,
		AisHighlight,
		AisSearchBox,
		AisStats,
		AisPagination,
	},
	data() {
		return {
			searchClient,
		};
	},
	head() {
		return {
			link: [
				{
					rel: "stylesheet",
					href: "https://cdn.jsdelivr.net/npm/instantsearch.css@8.17.0/themes/satellite-min.css",
				},
			],
		};
	},
};
5

Configure Vue InstantSearch for SSR

  1. Add createServerRootMixin to create a reusable search instance.
  2. Add findResultsState in serverPrefetch to perform a search query in the backend.
  3. Call the hydrate method in beforeMount.
  4. Replace ais-instant-search with ais-instant-search-ssr
6

Provide the instance to the component

Add the createRootMixin:
<template>
  <ais-instant-search-ssr>
    <ais-search-box />
    <ais-stats />
    <ais-refinement-list attribute="brand" />
    <ais-hits>
      <template v-slot:item="{ item }">
        <p>
          <ais-highlight attribute="name" :hit="item" />
        </p>
        <p>
          <ais-highlight attribute="brand" :hit="item" />
        </p>
      </template>
    </ais-hits>
    <ais-pagination />
  </ais-instant-search-ssr>
</template>

<script>
import {
  AisInstantSearchSsr,
  AisRefinementList,
  AisHits,
  AisHighlight,
  AisSearchBox,
  AisStats,
  AisPagination,
  createServerRootMixin,
} from "vue-instantsearch/vue3/es";
import { liteClient as algoliasearch } from "algoliasearch/lite";
import _renderToString from "vue-server-renderer/basic";

function renderToString(app) {
  return new Promise((resolve, reject) => {
    _renderToString(app, (err, res) => {
      if (err) reject(err);
      resolve(res);
    });
  });
}

const searchClient = algoliasearch(
  "latency",
  "6be0576ff61c053d5f9a3225e2a90f76",
);

export default {
  mixins: [
    createServerRootMixin({
      searchClient,
      indexName: "instant_search",
    }),
  ],
  serverPrefetch() {
    return this.instantsearch
      .findResultsState({
        component: this,
        renderToString,
      })
      .then((algoliaState) => {
        this.$ssrContext.nuxt.algoliaState = algoliaState;
      });
  },
  beforeMount() {
    const results =
      (this.$nuxt.context && this.$nuxt.context.nuxtState.algoliaState) ||
      window.__NUXT__.algoliaState;

    this.instantsearch.hydrate(results);

    // Remove the SSR state so it can't be applied again by mistake
    delete this.$nuxt.context.nuxtState.algoliaState;
    delete window.__NUXT__.algoliaState;
  },
  components: {
    AisInstantSearchSsr,
    AisRefinementList,
    AisHits,
    AisHighlight,
    AisSearchBox,
    AisStats,
    AisPagination,
  },
  head() {
    return {
      link: [
        {
          rel: "stylesheet",
          href: "https://cdn.jsdelivr.net/npm/instantsearch.css@8.17.0/themes/satellite-min.css",
        },
      ],
    };
  },
};
</script>
Last modified on May 19, 2026